"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isMatch = void 0;
var isString = function (str) { return typeof str === 'string'; };
var isRegExp = function (str) { return str instanceof RegExp; };
var isPredicate = function (str) {
    return typeof str === 'function';
};
var isMatch = function (str, matcher) {
    if (isString(matcher)) {
        return str === matcher;
    }
    if (isRegExp(matcher)) {
        return matcher.test(str);
    }
    if (isPredicate(matcher)) {
        return matcher(str);
    }
    return false;
};
exports.isMatch = isMatch;
