"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var cli_progress_1 = __importDefault(require("cli-progress"));
var fs_1 = __importDefault(require("fs"));
var optionator_1 = __importDefault(require("optionator"));
var path_1 = __importDefault(require("path"));
var processDatabase_1 = __importDefault(require("./processDatabase"));
// @ts-ignore
var version = require('../package.json').version;
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var o, options, config, configFile, bar, progress, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.info(chalk_1.default.greenBright('Kanel'));
                    o = (0, optionator_1.default)({
                        prepend: 'Usage: kanel [options]',
                        append: "Version ".concat(version),
                        options: [
                            {
                                option: 'help',
                                alias: 'h',
                                type: 'Boolean',
                                description: 'displays help',
                            },
                            {
                                option: 'version',
                                alias: 'v',
                                type: 'Boolean',
                                description: 'displays version',
                            },
                            {
                                option: 'config',
                                alias: 'c',
                                type: 'path::String',
                                description: 'Use this configuration, overriding .kanelrc.js config options if present',
                            },
                            {
                                option: 'database',
                                alias: 'd',
                                type: 'string',
                                description: 'Database connection string. Will override the connection field in the config file if present',
                            },
                            {
                                option: 'output',
                                alias: 'o',
                                type: 'path::String',
                                description: 'Output directory. Will override the output field in the config file if present',
                            },
                        ],
                    });
                    try {
                        options = o.parseArgv(process.argv);
                    }
                    catch (error) {
                        console.error(error.message);
                        process.exit(1);
                    }
                    if (options.help) {
                        console.info(o.generateHelp());
                        process.exit(0);
                    }
                    if (options.version) {
                        console.info(version);
                        process.exit(0);
                    }
                    configFile = path_1.default.join(process.cwd(), options.config || '.kanelrc.js');
                    if (fs_1.default.existsSync(configFile) ||
                        fs_1.default.existsSync(configFile + '.js') ||
                        fs_1.default.existsSync(configFile + '.json')) {
                        console.info("Using config file: ".concat(configFile));
                        try {
                            config = require(configFile);
                        }
                        catch (error) {
                            console.error('Could not open config file:', error);
                            process.exit(1);
                        }
                    }
                    else {
                        if (options.config) {
                            console.error('Could not open ' + options.config);
                            process.exit(1);
                        }
                        config = { connection: undefined };
                    }
                    if (options.database) {
                        config.connection = options.database;
                    }
                    if (!config.connection) {
                        console.error('No database specified, in config file or command line');
                        process.exit(1);
                    }
                    if (options.output) {
                        config.outputPath = options.output;
                    }
                    if (!config.outputPath) {
                        console.error('No output path specified, in config file or command line');
                        process.exit(1);
                    }
                    bar = new cli_progress_1.default.SingleBar({}, cli_progress_1.default.Presets.shades_classic);
                    progress = {
                        onProgressStart: function (total) { return bar.start(total, 0); },
                        onProgress: function () { return bar.increment(); },
                        onProgressEnd: function () { return bar.stop(); },
                    };
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, (0, processDatabase_1.default)(config, progress)];
                case 2:
                    _a.sent();
                    process.exit(0);
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    console.error(error_1);
                    process.exit(1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
main();
