"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = __importStar(require("ramda"));
var resolveType_1 = __importDefault(require("./resolveType"));
var generateProperties = function (details, generateFor, config) {
    var ps = details.kind === 'compositeType' ? details.attributes : details.columns;
    var sortedPs = config.propertySortFunction
        ? R.sort(config.propertySortFunction, ps)
        : ps;
    var result = sortedPs.map(function (p) {
        var _a = config.getPropertyMetadata(p, details, generateFor, config), name = _a.name, comment = _a.comment, typeOverride = _a.typeOverride, nullableOverride = _a.nullableOverride, optionalOverride = _a.optionalOverride;
        var canBeOptional = p.isNullable || p.defaultValue || p.isIdentity;
        var t = typeOverride !== null && typeOverride !== void 0 ? typeOverride : (0, resolveType_1.default)(p, details, config);
        var typeName;
        var typeImports = [];
        if (typeof t === 'string') {
            typeName = t;
        }
        else {
            typeName = t.name;
            typeImports = [t];
        }
        var isOptional;
        if (optionalOverride !== undefined) {
            isOptional = optionalOverride;
        }
        else {
            if (generateFor === 'selector') {
                isOptional = false;
            }
            else if (generateFor === 'initializer') {
                isOptional = canBeOptional;
            }
            else if (generateFor === 'mutator') {
                isOptional = true;
            }
            else {
                throw new Error("Unexpected generateFor value: ".concat(generateFor));
            }
        }
        var isNullable = Boolean(nullableOverride !== null && nullableOverride !== void 0 ? nullableOverride : p.isNullable);
        return {
            name: name,
            comment: comment,
            dimensions: p.isArray ? 1 : 0,
            isNullable: isNullable,
            isOptional: isOptional,
            typeName: typeName,
            typeImports: typeImports,
        };
    });
    return result;
};
exports.default = generateProperties;
