"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var generateIndexFile = function (outputAcc, instantiatedConfig) {
    var _a;
    var allEntities = Object.values(instantiatedConfig.schemas).reduce(function (acc, elem) {
        var entitiesInSchema = Object.values(elem)
            .filter(Array.isArray)
            .reduce(function (acc2, elem2) { return __spreadArray(__spreadArray([], acc2, true), elem2, true); }, []);
        return __spreadArray(__spreadArray([], acc, true), entitiesInSchema, true);
    }, []);
    var lines = allEntities.map(function (d) {
        var result;
        var _a = instantiatedConfig.getMetadata(d, 'selector', instantiatedConfig), path = _a.path, selectorName = _a.name;
        var importPath = (0, path_1.relative)(instantiatedConfig.outputPath, path);
        // We never want Windows-style paths in our source. Fix it if necessary.
        if (path_1.sep === '\\') {
            importPath = importPath.replace(/\\/g, '/');
        }
        if (d.kind === 'table') {
            var additionalImports_1 = [];
            var initializerName = instantiatedConfig.getMetadata(d, 'initializer', instantiatedConfig).name;
            additionalImports_1.push(initializerName);
            var mutatorName = instantiatedConfig.getMetadata(d, 'mutator', instantiatedConfig).name;
            additionalImports_1.push(mutatorName);
            if (instantiatedConfig.generateIdentifierType) {
                var identifierColumns = d.columns.filter(function (c) { return c.isPrimaryKey && !c.reference; });
                identifierColumns.forEach(function (c) {
                    var name = instantiatedConfig.generateIdentifierType(c, d, instantiatedConfig).name;
                    additionalImports_1.push(name);
                });
            }
            result = "export type { default as ".concat(selectorName, ", ").concat(additionalImports_1.join(', '), " } from './").concat(importPath, "';");
        }
        else if (d.kind === 'enum') {
            var prefix = instantiatedConfig.enumStyle === 'type' ? 'type ' : '';
            result = "export ".concat(prefix, "{ default as ").concat(selectorName, " } from './").concat(importPath, "';");
        }
        else {
            result = "export type { default as ".concat(selectorName, " } from './").concat(importPath, "';");
        }
        return result;
    });
    var indexFile = {
        declarations: [
            {
                declarationType: 'generic',
                lines: lines,
            },
        ],
    };
    var path = (0, path_1.join)(instantiatedConfig.outputPath, 'index');
    return __assign(__assign({}, outputAcc), (_a = {}, _a[path] = indexFile, _a));
};
exports.default = generateIndexFile;
