import { TableColumn, TableDetails } from 'extract-pg-schema';
import { InstantiatedConfig } from './Config';
import { TypeDeclaration } from './declaration-types';
import Details from './Details';
import { CompositeDetails, CompositeProperty } from './generators/composite-types';
import TypeImport from './TypeImport';
export declare type TypeMetadata = {
    name: string;
    comment: string[] | undefined;
    path: string;
};
export declare type GetMetadata = (details: Details, generateFor: 'selector' | 'initializer' | 'mutator' | undefined, instantiatedConfig: InstantiatedConfig) => TypeMetadata;
export declare type PropertyMetadata = {
    name: string;
    comment: string[] | undefined;
    typeOverride?: TypeImport | string;
    nullableOverride?: boolean;
    optionalOverride?: boolean;
};
export declare type GetPropertyMetadata = (property: CompositeProperty, details: CompositeDetails, generateFor: 'selector' | 'initializer' | 'mutator', instantiatedConfig: InstantiatedConfig) => PropertyMetadata;
export declare type GenerateIdentifierType = (column: TableColumn, details: TableDetails, instantiatedConfig: InstantiatedConfig) => TypeDeclaration;
