"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var extract_pg_schema_1 = require("extract-pg-schema");
var rmfr_1 = __importDefault(require("rmfr"));
var default_metadata_generators_1 = require("./default-metadata-generators");
var defaultTypeMap_1 = __importDefault(require("./defaultTypeMap"));
var makeCompositeGenerator_1 = __importDefault(require("./generators/makeCompositeGenerator"));
var makeDomainsGenerator_1 = __importDefault(require("./generators/makeDomainsGenerator"));
var makeEnumsGenerator_1 = __importDefault(require("./generators/makeEnumsGenerator"));
var makeRangesGenerator_1 = __importDefault(require("./generators/makeRangesGenerator"));
var markAsGenerated_1 = __importDefault(require("./hooks/markAsGenerated"));
var render_1 = __importDefault(require("./render"));
var writeFile_1 = __importDefault(require("./writeFile"));
var processDatabase = function (config, progress) { return __awaiter(void 0, void 0, void 0, function () {
    var schemas, typeMap, getMetadata, getPropertyMetadata, generateIdentifierType, propertySortFunction, instantiatedConfig, generators, output, preRenderHooks, _i, preRenderHooks_1, hook, filesToWrite, postRenderHooks, _loop_1, _a, postRenderHooks_1, hook;
    var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return __generator(this, function (_m) {
        switch (_m.label) {
            case 0: return [4 /*yield*/, (0, extract_pg_schema_1.extractSchemas)(config.connection, __assign({ schemas: config.schemas, typeFilter: config.typeFilter }, progress))];
            case 1:
                schemas = _m.sent();
                typeMap = __assign(__assign({}, defaultTypeMap_1.default), config.customTypeMap);
                getMetadata = (_b = config.getMetadata) !== null && _b !== void 0 ? _b : default_metadata_generators_1.defaultGetMetadata;
                getPropertyMetadata = (_c = config.getPropertyMetadata) !== null && _c !== void 0 ? _c : default_metadata_generators_1.defaultGetPropertyMetadata;
                generateIdentifierType = (_d = config.generateIdentifierType) !== null && _d !== void 0 ? _d : default_metadata_generators_1.defaultGenerateIdentifierType;
                propertySortFunction = (_e = config.propertySortFunction) !== null && _e !== void 0 ? _e : default_metadata_generators_1.defaultPropertySortFunction;
                instantiatedConfig = {
                    getMetadata: getMetadata,
                    getPropertyMetadata: getPropertyMetadata,
                    generateIdentifierType: generateIdentifierType,
                    propertySortFunction: propertySortFunction,
                    enumStyle: (_f = config.enumStyle) !== null && _f !== void 0 ? _f : 'enum',
                    typeMap: typeMap,
                    schemas: schemas,
                    connection: config.connection,
                    outputPath: (_g = config.outputPath) !== null && _g !== void 0 ? _g : '.',
                    preDeleteOutputFolder: (_h = config.preDeleteOutputFolder) !== null && _h !== void 0 ? _h : false,
                    resolveViews: (_j = config.resolveViews) !== null && _j !== void 0 ? _j : true,
                };
                generators = [
                    (0, makeCompositeGenerator_1.default)('table', instantiatedConfig),
                    (0, makeCompositeGenerator_1.default)('view', instantiatedConfig),
                    (0, makeCompositeGenerator_1.default)('materializedView', instantiatedConfig),
                    (0, makeCompositeGenerator_1.default)('compositeType', instantiatedConfig),
                    (0, makeEnumsGenerator_1.default)(instantiatedConfig),
                    (0, makeRangesGenerator_1.default)(instantiatedConfig),
                    (0, makeDomainsGenerator_1.default)(instantiatedConfig),
                ];
                output = {};
                Object.values(schemas).forEach(function (schema) {
                    generators.forEach(function (generator) {
                        output = generator(schema, output);
                    });
                });
                preRenderHooks = (_k = config.preRenderHooks) !== null && _k !== void 0 ? _k : [];
                _i = 0, preRenderHooks_1 = preRenderHooks;
                _m.label = 2;
            case 2:
                if (!(_i < preRenderHooks_1.length)) return [3 /*break*/, 5];
                hook = preRenderHooks_1[_i];
                return [4 /*yield*/, hook(output, instantiatedConfig)];
            case 3:
                output = _m.sent();
                _m.label = 4;
            case 4:
                _i++;
                return [3 /*break*/, 2];
            case 5:
                filesToWrite = Object.keys(output).map(function (path) {
                    var lines = (0, render_1.default)(output[path].declarations, path);
                    return { fullPath: "".concat(path, ".ts"), lines: lines };
                });
                postRenderHooks = (_l = config.postRenderHooks) !== null && _l !== void 0 ? _l : [markAsGenerated_1.default];
                _loop_1 = function (hook) {
                    return __generator(this, function (_o) {
                        switch (_o.label) {
                            case 0: return [4 /*yield*/, Promise.all(filesToWrite.map(function (file) { return __awaiter(void 0, void 0, void 0, function () {
                                    var lines;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, hook(file.fullPath, file.lines, instantiatedConfig)];
                                            case 1:
                                                lines = _a.sent();
                                                return [2 /*return*/, __assign(__assign({}, file), { lines: lines })];
                                        }
                                    });
                                }); }))];
                            case 1:
                                filesToWrite = _o.sent();
                                return [2 /*return*/];
                        }
                    });
                };
                _a = 0, postRenderHooks_1 = postRenderHooks;
                _m.label = 6;
            case 6:
                if (!(_a < postRenderHooks_1.length)) return [3 /*break*/, 9];
                hook = postRenderHooks_1[_a];
                return [5 /*yield**/, _loop_1(hook)];
            case 7:
                _m.sent();
                _m.label = 8;
            case 8:
                _a++;
                return [3 /*break*/, 6];
            case 9:
                if (!instantiatedConfig.preDeleteOutputFolder) return [3 /*break*/, 11];
                console.info("Clearing old files in ".concat(instantiatedConfig.outputPath));
                return [4 /*yield*/, (0, rmfr_1.default)(instantiatedConfig.outputPath, { glob: true })];
            case 10:
                _m.sent();
                _m.label = 11;
            case 11:
                filesToWrite.forEach(writeFile_1.default);
                return [2 /*return*/];
        }
    });
}); };
exports.default = processDatabase;
